<?php

/**
 * cpds actions.
 *
 * @package    inventario
 * @subpackage cpds
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
/*
 *  @author:egiraldo
 */
class cdpsActions extends sfActions {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
//            if (isset($request['_startRow'])) {
//                $rowStart = $request['_startRow'];
//            } else {
            $rowStart = 0;
//            }
//            if (isset($request['_endRow'])) {
//                $rowEnd = $request['_endRow'];
//            } else {
            $rowEnd = 1000;
//            }

            /*
             * variables de filtro
             */

            $whereVigencia = ' '; // id_vigencia , id_meses, id_linea , id_catalogo , id_clase , id_inventario_dv
            if (isset($request['id_vigencia'])) {
                $whereVigencia = " AND tab1.id_vigencia = '" . $request['id_vigencia'] . "' ";
            }

            $whereProyecto = ' '; // id_vigencia , id_meses, id_linea , id_catalogo , id_clase , id_inventario_dv

            $id_proyecto_ep = $request['id_proyecto_ep'];

            if (isset($request['id_proyecto_ep'])) {

                $sql = <<<EOD
select id_cpo from co_proyecto_ep where id_proyecto_ep = $id_proyecto_ep
EOD;

                $records = CN_TABLE::executeSQL($sql);
                $id_cpo = $records[0]['id_cpo'];

                $whereProyecto = " AND tab0.id_cpo = '" . $id_cpo . "' ";
            }




            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
    select   
    tab0.id as id, 
    tab0.cdp as cdp, tab0.vigencia as vigencia, 
    to_char(tab0.fecha, 'YYYY-MM-DD') as fecha_cdp, 
    tab0.valor as valor,tab0.saldo as saldo, 
    tab0.cdp||' - '||tab0.vigencia as completo,
    (select count(*) from co_cdps_ep where id_cdp = tab0.id) AS CANTIDAD,
    tab0.SGR
    
    from co_cdps_v tab0 
                    
    WHERE  
    tab0.cdp != '-1' $whereProyecto 
        
    ORDER BY 
    cdp ASC 
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                $sql = <<<EOD
select   
tab0.id as id, 
tab0.cdp as cdp, tab0.vigencia as vigencia, 
to_char(tab0.fecha, 'YYYY-MM-DD') as fecha_cdp, 
tab0.valor as valor,tab0.saldo as saldo, 
tab0.cdp||' - '||tab0.vigencia as completo,
(select count(*) from co_cdps_ep where id_cdp = tab0.id) AS CANTIDAD,
tab0.SGR

from co_cdps_v tab0 

WHERE  
tab0.cdp != '-1' $whereProyecto 

ORDER BY 
cdp ASC 
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('in_cdps');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $total_record_count;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[cpds] Consulta exitosa.");
            } else {

                $mensaje = "[cpds] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[cpds] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
